from microbit import *
import random
#Modified with the updates requested by S3 Physics at Liberton High School

import math
status = False
Horizlin = Image("00000:00000:99999:00000:00000")
Pattern1 = Image("05050:00000:00900:00900:00000")

Pattern2 = Image("00000:09000:00090:00000:00000")

Pattern3 = Image("00000:00000:00090:00500:00005")

Pattern4 = Image("00900:50000:00000:00009:50000")

Pattern5 = Image("05050:00000:00900:00900:00000")

Pattern6 = Image("00000:09000:00090:00000:00500")

Pattern7 = Image("00050:00090:00090:00500:00005")

Pattern8 = Image("00900:00000:00000:00009:50000")

Pattern9 = Image("00000:99099:99099:00000:00000")

Patterns = [Pattern1, Pattern2, Pattern3, Pattern4, Pattern5, Pattern6, Pattern7, Pattern8, Pattern9]
road = ["D","W","I"]

coef = [13.19, 7.84, 1.96]

speed = ["20","30","40","50","60","70"]

vel = [8.9,13.4,17.9,22.4,26.8,31.3]

accum = 6

index = 6

display.scroll("road = ", delay=100)

display.scroll(road[accum%3], delay=100)

display.scroll("A, B", delay=100)
sleep(100)


while True:
    display.show(Horizlin)

    sleep(100)
    if button_b.is_pressed():
        display.show(Image.YES)
        sleep(300)
        break

    elif button_a.is_pressed():
        accum = accum + 1
        display.scroll(road[accum%3], delay=100)
    sleep(100)   

display.scroll("s = ", delay=100)

display.scroll(speed[index%6], delay=100)

display.scroll("A, B", delay=100)

sleep(500)


while True:

    display.show(Horizlin)

    sleep(100)

    if button_b.is_pressed():

        display.show(Image.YES)

        sleep(300)

        break



    elif button_a.is_pressed():

        index = index + 1

        display.scroll(speed[index%6], delay=100)

    sleep(100)   

display.show(Image.HAPPY)

sleep(500)    
display.scroll("A/B", delay=100)

while True:

    display.show(Horizlin)

    sleep(100)

    if button_b.is_pressed():

        break

    elif button_a.is_pressed():

        break
         
display.show(Image.YES)

sleep(500)



while button_a.is_pressed() or button_b.is_pressed():

    sleep(100)

while status == False:
    cy = random.randint(0,8)

    display.show(Patterns[cy])    

    if cy == 8:

        starttime = running_time()

        status = True

        break

        
    elif button_a.is_pressed() or button_b.is_pressed():

        display.show(Image.NO)

        sleep(300)

        reset()

        
    sleep(70)

    


while True:

#wait for button press   
    if button_b.is_pressed() or button_a.is_pressed():

        break

rtime = running_time() - starttime


brakedist = vel[index%6]*vel[index%6]/coef[accum%3]
brakedist = round(brakedist)
thinkingdist = vel[index%6]*rtime*0.001
thinkingdist = round(thinkingdist)
stopdist = brakedist+thinkingdist
stopdist = round(stopdist)


display.show(Image.HAPPY)

sleep(700)



while True:
    

    if button_b.is_pressed() or button_a.is_pressed():

        reset()

    else:
        display.scroll("RT= "+str(rtime)+"ms", delay=100)

        display.scroll("TD= "+str(thinkingdist)+"m", delay=100)

        display.scroll("BD= "+str(brakedist)+"m", delay=100)

        display.scroll("SD= "+str(stopdist)+"m", delay=100)

        display.show(Horizlin)

        sleep(500)




